---

########################################################
# gitaly_version_check.yml
#
# This play is responsible for validating the version of
# Gitaly running matches that of the installed version.
# If not, we intentionally bail to prevent Deployer from
# continuing as if nothing is wrong.  This would be
# common when the installation of GitLab is complete,
# but the restart of Gitaly did not successfully complete.
# A retry of the install will skip reloading Gitaly, so
# this is here as a secondary measure to prevent
# deployments from being allowed to continue.

- name: Ensure Gitaly Version Running matches Gitaly Version Installed
  become: true
  ansible.builtin.command: /etc/ansible/facts.d/gitlab.fact
  register: service_version
  until: (service_version.stdout | from_json)['running_version_gitaly'] == (service_version.stdout | from_json)['version_gitaly']
  delay: 3
  changed_when: false
  check_mode: false
  retries: 20
  when: is_gitaly_role

- name: Ensure Praefect Version Running matches Praefect Version Installed
  become: true
  ansible.builtin.command: /etc/ansible/facts.d/gitlab.fact
  register: service_version
  until: (service_version.stdout | from_json)['running_version_praefect'] == (service_version.stdout | from_json)['version_praefect']
  delay: 3
  changed_when: false
  check_mode: false
  retries: 20
  when: is_praefect_role
